// +build dev

package assets

import (
	"net/http"

	"github.com/shurcooL/httpfs/union"
)

// Assets contains files that will be included in the binary
// this is a union file system, so to reach the expected file
// the root folder defined in the map should be prepended
// to the file path
var Assets = union.New(map[string]http.FileSystem{
	"/migrations": http.Dir("./assets/migrations"),
	"/templates":  http.Dir("./assets/templates"),
	"/static":     http.Dir("./assets/static"),
})
