// Code generated by sqlc. DO NOT EDIT.

package database

import (
	"database/sql"
	"time"
)

type Email struct {
	Address    string    `json:"address"`
	IdentityID int64     `json:"identity_id"`
	IsVerified bool      `json:"is_verified"`
	IsPrimary  bool      `json:"is_primary"`
	CreatedAt  time.Time `json:"created_at"`
}

type EmailConfirmation struct {
	EmailAddress string    `json:"email_address"`
	Selector     string    `json:"selector"`
	Verifier     []byte    `json:"verifier"`
	ValidUntil   time.Time `json:"valid_until"`
}

type ExternalAuth struct {
	Name         string         `json:"name"`
	OidcUrl      sql.NullString `json:"oidc_url"`
	AuthUrl      string         `json:"auth_url"`
	TokenUrl     string         `json:"token_url"`
	ClientKey    string         `json:"client_key"`
	ClientSecret string         `json:"client_secret"`
	CreatedAt    time.Time      `json:"created_at"`
}

type ExternalUser struct {
	IdentityID       int64          `json:"identity_id"`
	ExternalAuthName string         `json:"external_auth_name"`
	ExternalID       string         `json:"external_id"`
	AuthToken        sql.NullString `json:"auth_token"`
	RefreshToken     sql.NullString `json:"refresh_token"`
	IdentityToken    sql.NullString `json:"identity_token"`
}

type Identity struct {
	ID         int64          `json:"id"`
	Login      sql.NullString `json:"login"`
	Passphrase []byte         `json:"passphrase"`
	TotpSecret sql.NullString `json:"totp_secret"`
	IsAdmin    bool           `json:"is_admin"`
	IsDisabled bool           `json:"is_disabled"`
	CreatedAt  time.Time      `json:"created_at"`
}

type PasswordReset struct {
	IdentityID int64     `json:"identity_id"`
	Selector   string    `json:"selector"`
	Verifier   []byte    `json:"verifier"`
	ValidUntil time.Time `json:"valid_until"`
}

type Person struct {
	IdentityID  int64          `json:"identity_id"`
	DisplayName sql.NullString `json:"display_name"`
	FirstName   sql.NullString `json:"first_name"`
	LastName    sql.NullString `json:"last_name"`
	ImageUrl    sql.NullString `json:"image_url"`
	Zoneinfo    sql.NullString `json:"zoneinfo"`
	Locale      sql.NullString `json:"locale"`
}
