package web

import (
	"net/http"

	"bitmask.me/skeleton/internal/app"
	"github.com/go-chi/chi"
)

func runHTTP(listenAddr string, h http.Handler) error {
	server := &http.Server{
		Addr:    listenAddr,
		Handler: h,
	}
	return server.ListenAndServe()
}

// RunServer starts the web server
func RunServer(ac *app.App, listenAddr string) {
	r := chi.NewMux()
	registerRoutes(ac, r)

	runHTTP(listenAddr, r)
}
